//=============================================================================
// Flying Shark.  - A fly/devilfish mutant.  2015 - Mr.Loathsome
//=============================================================================
class FS extends Fly;

function PreSetMovement()
{
	bCanJump = true;
	bCanWalk = true;
	bCanSwim = true;
	bCanFly = true;
	MinHitWall = -0.6;
	bCanOpenDoors = true;
	bCanDoSpecial = false;
}

function PlayWaiting()
{
	if ( Physics == PHYS_Walking )
		TweenAnim('breathing', 10.0);
	else
		LoopAnim('Swimming', 0.75);
}

function PlayChallenge()
{
	if ( FRand() < 0.330 )
		PlayAnim('bite1', 1.0, 0.1);
	else
	if ( FRand() < 0.330 )
		PlayAnim('bite2', 1.0, 0.1);
	else
		PlayAnim('bite3', 1.0, 0.1);
}

function TweenToFighter(float tweentime)
{
	TweenAnim('Swimming', tweentime);
}

function TweenToRunning(float tweentime)
{
	if ( (AnimSequence != 'Swimming') || !bAnimLoop )
		TweenAnim('Swimming', tweentime);
}

function TweenToWalking(float tweentime)
{
	if (Physics == PHYS_Walking)
		TweenAnim('breathing', tweentime);
	else if ( (AnimSequence != 'Swimming') || !bAnimLoop )
		TweenAnim('Swimming', tweentime);
}

function TweenToWaiting(float tweentime)
{
	PlayAnim('flopping', 0.2 + 0.5 * FRand());
	SetPhysics(PHYS_Falling);
}

function TweenToPatrolStop(float tweentime)
{
	TweenAnim('Swimming', tweentime);
}

function PlayRunning()
{
	LoopAnim('Swimming');
}

function PlayWalking()
{
	if (Physics == PHYS_Walking)
		LoopAnim('breathing', -1.0/GroundSpeed,, 0.4);
	else
		LoopAnim('Swimming');
}

function PlayThreatening()
{
	if ( FRand() < 0.8 )
		LoopAnim('Swimming');
	else
		LoopAnim('bite2', 0.4);
}

function PlayTurning()
{
	if (Physics == PHYS_Walking)
		LoopAnim('breathing');
	else
		LoopAnim('Swimming');
}

function PlayDying(name DamageType, vector HitLocation)
{
	if ( FRand() < 0.50 )
	{
		PlayAnim('breathing', 0.1 + (0.5 * FRand()),0.1250 + (4.0 * FRand()));
	}
	else
	if ( FRand() < 0.50 )
	{
		PlayAnim('flopping', 0.1 + (0.5 * FRand()),0.1250 + (4.0 * FRand()));
		
	}
	else PlayAnim('ripper', 0.1 + (0.5 * FRand()),0.1250 + (4.0 * FRand()));
	PlaySound(Die, SLOT_Talk, 2.5 * TransientSoundVolume);
	if (FRand() < 0.330) PlayDying(DamageType, HitLocation);
}

function PlayTakeHit(float tweentime, vector HitLoc, int damage)
{
	if (FRand() < 0.330) PlayAnim('ripper', 1.2,0.4);
	else TweenAnim('TakeHit', tweentime);
}

function TweenToFalling()
{
	TweenAnim('Swimming', 0.2);
}

function PlayInAir()
{
	LoopAnim('Swimming');
}

function PlayLanded(float impactVel)
{
	PlayAnim('flopping');
}

function PlayVictoryDance()
{
	PlayAnim('ripper');
	if ( FRand() < 0.4 )
		TweenToWaiting(0.25);
	else
		PlayAnim('grab1',1.0, 0.05);
}
	
function PlayMeleeAttack()
{
	if ( FRand() < 0.330 )
		PlayAnim('bite1', 1.0, 0.1);
	else
	if ( FRand() < 0.330 )
		PlayAnim('bite2', 1.0, 0.1);
	else
		PlayAnim('bite3', 1.0, 0.1);
	if ( MeleeDamageTarget(15, (15 * 1000.0 * Normal(Target.Location - Location))) )
//		PlaySound(Threaten, SLOT_Talk); //FIXME - stingdamage instead of projectile
		PlaySound(HitSound2, SLOT_Talk);
	GotoState('TacticalMove', 'BackOff');
}

function PlayRangedAttack()
{
	if ( FRand() < 0.5 )
		PlayAnim('bite3');
	else
		PlayAnim('bite2');
}

defaultproperties
{
     CarcassType=Class'UnrealShare.DevilfishCarcass'
     WaterSpeed=300.000000
     Health=90
     HitSound1=Sound'UnrealShare.Razorfish.chomp1fs'
     HitSound2=Sound'UnrealShare.Razorfish.miss1fs'
     Land=Sound'UnrealShare.Razorfish.flop1fs'
     Die=Sound'UnrealShare.Razorfish.death1fs'
     CombatStyle=1.000000
     AmbientSound=Sound'UnrealShare.Razorfish.ambfs'
     Mesh=LodMesh'FlyingShark.fish'
     MenuName="Freaking Shark"
}
